// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:srv/GetCmdList.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "kompass_interfaces/srv/get_cmd_list.hpp"


#ifndef KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__TRAITS_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/srv/detail/get_cmd_list__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'follow_path'
#include "kompass_interfaces/msg/detail/follow_path_request__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetCmdList_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: number_of_cmds
  {
    out << "number_of_cmds: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_cmds, out);
    out << ", ";
  }

  // member: time_step
  {
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << ", ";
  }

  // member: follow_path
  {
    out << "follow_path: ";
    to_flow_style_yaml(msg.follow_path, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetCmdList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: number_of_cmds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_of_cmds: ";
    rosidl_generator_traits::value_to_yaml(msg.number_of_cmds, out);
    out << "\n";
  }

  // member: time_step
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_step: ";
    rosidl_generator_traits::value_to_yaml(msg.time_step, out);
    out << "\n";
  }

  // member: follow_path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "follow_path:\n";
    to_block_style_yaml(msg.follow_path, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetCmdList_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::GetCmdList_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::GetCmdList_Request & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::GetCmdList_Request>()
{
  return "kompass_interfaces::srv::GetCmdList_Request";
}

template<>
inline const char * name<kompass_interfaces::srv::GetCmdList_Request>()
{
  return "kompass_interfaces/srv/GetCmdList_Request";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetCmdList_Request>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::FollowPathRequest>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetCmdList_Request>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::FollowPathRequest>::value> {};

template<>
struct is_message<kompass_interfaces::srv::GetCmdList_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'cmd_list'
#include "kompass_interfaces/msg/detail/twist_array__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetCmdList_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: cmd_list
  {
    out << "cmd_list: ";
    to_flow_style_yaml(msg.cmd_list, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetCmdList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: cmd_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd_list:\n";
    to_block_style_yaml(msg.cmd_list, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetCmdList_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::GetCmdList_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::GetCmdList_Response & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::GetCmdList_Response>()
{
  return "kompass_interfaces::srv::GetCmdList_Response";
}

template<>
inline const char * name<kompass_interfaces::srv::GetCmdList_Response>()
{
  return "kompass_interfaces/srv/GetCmdList_Response";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetCmdList_Response>
  : std::integral_constant<bool, has_fixed_size<kompass_interfaces::msg::TwistArray>::value> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetCmdList_Response>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::msg::TwistArray>::value> {};

template<>
struct is_message<kompass_interfaces::srv::GetCmdList_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace kompass_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetCmdList_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetCmdList_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetCmdList_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::srv::GetCmdList_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::srv::GetCmdList_Event & msg)
{
  return kompass_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::srv::GetCmdList_Event>()
{
  return "kompass_interfaces::srv::GetCmdList_Event";
}

template<>
inline const char * name<kompass_interfaces::srv::GetCmdList_Event>()
{
  return "kompass_interfaces/srv/GetCmdList_Event";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetCmdList_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetCmdList_Event>
  : std::integral_constant<bool, has_bounded_size<kompass_interfaces::srv::GetCmdList_Request>::value && has_bounded_size<kompass_interfaces::srv::GetCmdList_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<kompass_interfaces::srv::GetCmdList_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<kompass_interfaces::srv::GetCmdList>()
{
  return "kompass_interfaces::srv::GetCmdList";
}

template<>
inline const char * name<kompass_interfaces::srv::GetCmdList>()
{
  return "kompass_interfaces/srv/GetCmdList";
}

template<>
struct has_fixed_size<kompass_interfaces::srv::GetCmdList>
  : std::integral_constant<
    bool,
    has_fixed_size<kompass_interfaces::srv::GetCmdList_Request>::value &&
    has_fixed_size<kompass_interfaces::srv::GetCmdList_Response>::value
  >
{
};

template<>
struct has_bounded_size<kompass_interfaces::srv::GetCmdList>
  : std::integral_constant<
    bool,
    has_bounded_size<kompass_interfaces::srv::GetCmdList_Request>::value &&
    has_bounded_size<kompass_interfaces::srv::GetCmdList_Response>::value
  >
{
};

template<>
struct is_service<kompass_interfaces::srv::GetCmdList>
  : std::true_type
{
};

template<>
struct is_service_request<kompass_interfaces::srv::GetCmdList_Request>
  : std::true_type
{
};

template<>
struct is_service_response<kompass_interfaces::srv::GetCmdList_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__TRAITS_HPP_
