// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from kompass_interfaces:srv/PathFromToFile.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "kompass_interfaces/srv/path_from_to_file.h"


#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_H_
#define KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'file_location'
// Member 'file_name'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/PathFromToFile in the package kompass_interfaces.
typedef struct kompass_interfaces__srv__PathFromToFile_Request
{
  /// path to save the path xml file location
  rosidl_runtime_c__String file_location;
  rosidl_runtime_c__String file_name;
} kompass_interfaces__srv__PathFromToFile_Request;

// Struct for a sequence of kompass_interfaces__srv__PathFromToFile_Request.
typedef struct kompass_interfaces__srv__PathFromToFile_Request__Sequence
{
  kompass_interfaces__srv__PathFromToFile_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__srv__PathFromToFile_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'global_path'
#include "nav_msgs/msg/detail/path__struct.h"

/// Struct defined in srv/PathFromToFile in the package kompass_interfaces.
typedef struct kompass_interfaces__srv__PathFromToFile_Response
{
  double path_length;
  nav_msgs__msg__Path global_path;
} kompass_interfaces__srv__PathFromToFile_Response;

// Struct for a sequence of kompass_interfaces__srv__PathFromToFile_Response.
typedef struct kompass_interfaces__srv__PathFromToFile_Response__Sequence
{
  kompass_interfaces__srv__PathFromToFile_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__srv__PathFromToFile_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  kompass_interfaces__srv__PathFromToFile_Event__request__MAX_SIZE = 1
};
// response
enum
{
  kompass_interfaces__srv__PathFromToFile_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/PathFromToFile in the package kompass_interfaces.
typedef struct kompass_interfaces__srv__PathFromToFile_Event
{
  service_msgs__msg__ServiceEventInfo info;
  kompass_interfaces__srv__PathFromToFile_Request__Sequence request;
  kompass_interfaces__srv__PathFromToFile_Response__Sequence response;
} kompass_interfaces__srv__PathFromToFile_Event;

// Struct for a sequence of kompass_interfaces__srv__PathFromToFile_Event.
typedef struct kompass_interfaces__srv__PathFromToFile_Event__Sequence
{
  kompass_interfaces__srv__PathFromToFile_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} kompass_interfaces__srv__PathFromToFile_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PATH_FROM_TO_FILE__STRUCT_H_
